
global foo

foo:


;Eric Martinsen 
;301 Assembly Language 
;Project 2: Text Adventure "Ascended" 
 
extern puts		; prints out the introduction and the options 
extern read_input	; Used to get the player choices from input box 
 
mov rdx, 0		;rdx holds value of scene #, starts at 0 
funcloop:		; after iteration of loop, returns back here 
 
           
mov rcx, rdx          ; to protect rdx from being changed 
mov rax, Settings     ; load up setting strings 
push rdx              ;save rdx value from 'puts' 
mov rdi, [rax+rcx*8]  ;load up setting based on what the scene count, rdx, is 
call puts            ;prints scene and options 
 
pop rdx 
cmp rdx, 7	;lets epilogue be printed out, but does not allow player option 
je epil		; jumps to a ret statement and ends program 
 
multattempt:	;used for looping when multiple choices in same scene are used 
 
push rdx 
 
badret:		;returns the player here again if they enter a bad value, so they can 
		;enter a new value 
 
call read_input ;reads the player choice from input box, range 1-4 
 
cmp rax, 1      ; makes sure value isn't below range 
jl bad 
 
cmp rax, 4	;makes sure value isn't above range 
jg bad 
 
pop rdx   
 
mov rcx, rdx	      ;once again so as not to change rdx 
push rdx 
imul rcx, 4	      ; select which block of option strings to choose from 
add rcx, rax          ; and add the number of the option the player selected  
sub rcx, 1	      ;take away one to line up strings, assuming player won't pick 0 
push rax 
mov rax, Responses    ; load the responses strings 
mov rdi, [rax+rcx*8]  ; based on all that, select the correct action string 
call puts           ; prints action 
pop rax 
pop rdx 
 
	      ; unfortunately due to branching, a series of compare jumps are needed 
	      ; The following is wretched, but the only way I could think to make 
	      ;it work.  If you look to the responses table, these jumps are mapped  
	      ;nicer in the comments 
 
 
 
;//////////////////////////////////////////////// 
 
cmp rdx, 0	; looks at what scene it just passed through, and based on that     
je sceneone 
 
cmp rdx, 1 
je scenetwo 
 
cmp rdx, 2 
je scenethree 
 
cmp rdx, 3 
je scenefour 
 
cmp rdx, 4 
je scenefive 
 
cmp rdx, 5 
je scenesix 
 
cmp rdx, 6 
je sceneseven 
 
;//////////////////////////////// ;provided for easier viewing 
sceneone:  ; checks if the choice leads to another scene based on the current scene 
 
cmp rax, 1 
je onetotwo 
 
jmp multattempt ;returns just before option choosing so scene opener isn't given 
		;each repeat when an exit path isn't chosen  
 
onetotwo:	;if exit path is chosen, increment the scene number 
add rdx, 1 
jmp funcloop 
;//////////////////////////////// 
 
scenetwo:	;This is repeated for each scene 
 
cmp rax, 2 
je twotoseven 
 
cmp rax, 3 
je twotothree 
 
jmp multattempt 
 
twotoseven: 
mov rdx, 6 
jmp funcloop 
 
twotothree: 
add rdx, 1 
jmp funcloop 
 
;//////////////////////////////////////////////// 
 
scenethree: 
 
cmp rax, 1 
je threetofour 
 
cmp rax, 2 
je threetosix 
 
cmp rax, 3 
je threetofive 
 
cmp rax, 4 
je threetotwo 
 
jmp multattempt           ;shouldn't be needed for this scene, but left to be sure 
 
threetofour: 
add rdx, 1 
jmp funcloop 
 
threetosix: 
mov rdx, 5 
jmp funcloop 
 
threetofive: 
mov rdx, 4 
jmp funcloop 
 
threetotwo: 
sub rdx, 1 
jmp funcloop 
;//////////////////////////////////// 
scenefour: 
cmp rax, 1 
je fourtothree 
 
cmp rax, 4 
je fourtothree 
 
jmp multattempt 
 
fourtothree: 
sub rdx, 1 
jmp funcloop 
;//////////////////////////////////// 
scenefive: 
cmp rax, 4 
je fivetothree 
 
jmp multattempt 
 
fivetothree: 
mov rdx, 2 
jmp funcloop 
;/////////////////////////////////// 
scenesix: 
cmp rax, 4 
je sixtothree 
 
jmp multattempt 
 
sixtothree: 
mov rdx, 2 
jmp funcloop 
;//////////////////////////////////// 
sceneseven: 
cmp rax, 1 
je trueend 
 
cmp rax, 3 
je notend 
 
mov rax,0 
ret 
 
trueend: 
add rdx, 1 
jmp funcloop 
 
notend: 
jmp multattempt 
;//////////////////////////////////// 
 
epil: 
ret 
;//////////////////////////////////// 
bad: ;bounds checking, prints out error message if bad value is given 
mov rdi, Invalid 
call puts 
jmp badret 
 
 
 
section .data 
 
Settings:         ;Pointers to pointers method, give it Settings, the increment to  
	dq Lawn	  ;gets each individual scene 
	dq Kitchen 
	dq Hallway 
	dq Attic 
	dq Bedroom 
	dq Bathroom 
	dq LivingRoom 
	dq Epilogue 
 
 
 
 
 
 
 
 
	;gonna add three more scenes once I have the other parts finished 
section .data 
 
Responses:                  ;all the responses 
	;scene 1 
	dq Response1_1 ;goes to scene 2 
	dq Response1_2 
	dq Response1_3 
	dq Response1_4 
 
	;scene 2 
	dq Response2_1 
	dq Response2_2 ;goes to scene 7 
	dq Response2_3 ;goes to scene 3 
	dq Response2_4 
 
	;scene 3 
	dq Response3_1 ;goes to scene 4 
	dq Response3_2 ;goes to scene 6 
	dq Response3_3 ;goes to scene 5 
	dq Response3_4 ;goes to scene 2 
 
	;scene 4 
	dq Response4_1 ;goes to scene 3 
	dq Response4_2 
	dq Response4_3 
	dq Response4_4 ;goes to scene 3 
 
	;scene 5 
	dq Response5_1 
	dq Response5_2 
	dq Response5_3 
	dq Response5_4 ;goes to scene 3 
 
	;scene 6 
	dq Response6_1 
	dq Response6_2 
	dq Response6_3 
	dq Response6_4 ;goes to scene 3 
 
	;scene 7 
	dq Response7_1 ;Goes to special complete ending 
	dq Response7_2 ;gives B ending 
	dq Response7_3 
	dq Response7_4 ;gives C ending 
 
;---------------------------------Scene 1 Responses---------------------------------- 
 
Response1_1:  
	db 0xA,'(1) You knock upon the door and a shrill cry rings out in response, "Enter!".', 0xA,' You hesitate, but mustering your courage you twist the handle and make your way inside...', 0xA, 0 
 
Response1_2: 
	db 0xA,'(2) The creatures fall before your thunderous blows.  While they may have slew a lesser man,', 0xA, ' they could not have dreamed of the destruction you have brought upon them.  You stand over ',0xA, 'one of the creatures and release a fearsome war cry, and as the clouds part the moon shines', 0xA, ' on the face of your foe...a ceramic garden gnome.', 0xA, 0 
 
Response1_3: 
	db 0xA,'(3) The creatures do not take notice of you as you weave from shadow to shadow, despite you singing', 0xA, ' the theme to Mission Impossible...whatever that might be.... and as you near the house, they', 0xA, ' remain staring across the field, still waiting for you...', 0xA, 0 
 
Response1_4: 
	db 0xA,'(4) You lay down where you stand, curl into a ball and weep openly.  thankfully the creatures', 0xA, ' do not take advantage of this moment of weakness, and that there is no one else there to see', 0xA, ' you in this state.',0xA, 0 
 
;---------------------------------Scene 2 Responses---------------------------------- 
 
Response2_1: 
	db 0xA,'(1) You slowly seat yourself in front of a plate at the table, and even more slowly raise one of ', 0xA, 'the bones up to your nose and sniff...a familiar smell. You take a tentative bite, and indeed', 0xA, '...teriyaki chicken...', 0xA, 0 
 
Response2_2: 
	db 0xA,'(2) You make your way towards the lit room and as you near the entrance you hear a pair of sinister', 0xA, ' voices whispering... ', 0xA, 0 
 
Response2_3: 
	db 0xA,'(3) Though your true path seems clear, you feel that it may be best to explore to understand your',0xA,'enemy and, of course, gain EXP.  You move to the darkened corridor at the far side of the room.', 0xA, 0 
 
Response2_4: 
	db 0xA,'(4) The pressure is too much.  You put your head in the oven and wait for the sweet embrace of death', 0xA, '.....................................................', 0xA, 'however after fifteen minutes you realize the oven is electric...Seek professional help.', 0xA, 0 
 
 
;---------------------------------Scene 3 responses---------------------------------- 
 
 
Response3_1:  
	db 0xA,'(1) Mustering your courage you plunge into the darkness and slowly climb the staircase...', 0xA, 0 
 
Response3_2: 
	db 0xA,'(2) The dim light intrigues you, while it is most befitting an evil creature, that is what you seek',0xA,' to destroy. You slowly and quietly pull the right side door open, then quickly spring inside.', 0xA, 0 
 
Response3_3: 
	db 0xA,'(3) Light seems a welcoming sign, and you hurriedly stumble in the left door', 0xA, 0 
 
Response3_4: 
	db 0xA,'(4)Satisfied with the EXP gained, you move back to the dining hall to pursue your quest again. ',0xA, 0 
 
 
;---------------------------------Scene 4 responses---------------------------------- 
 
 
Response4_1:  
	db 0xA,'(1) You slowly circle the beast, but to no avail, it is simply too fast.  It leaps down onto your',0xA,' face and latches on, biting your nose all the while hissing and roaring.  With all your might you',0xA,' get a hold of the beast and throw it off you.  The beast lands and and quickly disappears amongst',0xA,' the crates.  Unsure of what it was or where it went, you decide it would be best to leave before it',0xA,' comes back for more.', 0xA, 0 
 
Response4_2: 
	db 0xA,'(2) So as to not agitate the creature you peer into one of the crates opposite to it.  What you find',0xA,' is a gathering of items, ancient and arcane.  There are also miniature portraits, though you ',0xA,'recognize no one in them.  Likely that this is the treasure horde gained from centuries of conquest.',0xA,'  You feel you should return here once your quest is over to return the treasure to the people.', 0xA, 0 
 
Response4_3: 
	db 0xA,'(3) Cautiously you approach the creature until it releases a fearsome hiss. You stop and, unsure of',0xA,' what the creature is capable of, you decide it better to outsmart it.  You pose it a riddle, one that could',0xA,' give pause to the wisest of your villages elders.  After a pensive minute the beast answered with another ',0xA,'hiss.......which is not the right answer.  You win the contest of riddles!  Yay you! ',0xA,'Yu gaynd uh purmnent +1 tew Entellugunz', 0xA, 0 
 
Response4_4: 
	db 0xA,'(4) Despite the treasures this place holds, you cannot let it distract you from your quest, you make',0xA,' your way back down the stairs.',0xA, 0 
 
 
;---------------------------------Scene 5 Responses---------------------------------- 
;Congratulations if you recognize the "Baldur's Gate" reference  
 
Response5_1:  
	db 0xA,'(1) The sounds outside can mean only one thing...The fight for this fortress has finally come!  You',0xA,' quickly brace the door with everything at hand, but you decide to call it good after throwing down',0xA,' some of the bed pillows in front of the door.  Anyway, you ready yourself for combat and listen for',0xA,' the enemies approach:  The footsteps reach the middle of the corridor and...enter the room at the',0xA,' other side of the hall?  An uncomfortable minute passes and the other door opens again.  The footsteps',0xA,' go back down the corridor as a strange whooshing, gurgling sound comes from across the corridor.', 0xA, 0 
 
Response5_2: 
	db 0xA,'(2) You cannot abide your curiosity and you move to the armoire.  You open the doors and you gawk at',0xA,' the wonder that lies before you: A pair of Golden Pantaloons.  Though they may seem useless now, you',0xA,'feel they may one day be a piece of something greater.  You quickly stuff the newly acquired treasure',0xA,'down your own pantaloons and close the armoire doors.', 0xA, 0 
 
Response5_3: 
	db 0xA,'(3) The world can wait a while, best for you to keep your strength up.  You lay down on on the',0xA,'kingly bed and close your eyes.  Unfortunately you did not bring your knightly bear-friend with whom',0xA,' you always rest with.  With great disappointment you get back up, and make a mental note to not',0xA,'forget him next time.', 0xA, 0 
 
Response5_4: 
	db 0xA,'(4) You hesitantly pull away from the grandeur of this room, and make you way back into the',0xA,'dark corridor.',0xA, 0 
 
 
;---------------------------------Scene 6 Responses---------------------------------- 
 
 
Response6_1:  
	db 0xA,'(1) You approach the podium and pear into the mirror.  What you see causes you to flinch...this is not',0xA,' right...You are a dashing prince...Clearly this must be a window into the "Evil Realm"...and your',0xA,' "Evil Self" looking back at you....Yeah....Thats it...', 0xA, 0 
 
Response6_2: 
	db 0xA,'(2) Though risky, you feel that one of these potions throughout the room may make you more powerful.',0xA,'You close your eyes and let fate decide.  You reach out and grab hold of a small goblet.  With a deep',0xA,'breath you drink deep of the goblet, and are smacked in the face by a pair of teeth an instant later.', 0xA,'+1 to Health',0xA,'-1 to Intelligence',0xA,'+1 to Dental Hygiene',0xA,'+5 Mintiness',0xA,0 
 
Response6_3: 
	db 0xA,'(3) You examine the crystalline chamber in closer detail.  You step into the box and immediately',0xA,'slip on some sort of green stone.  As you fall you try to catch yourself, but manage only to knock',0xA,'over some of the mysterious elixir bottles that litter the chamber, making one of them spray its',0xA,'contents onto your face.  You shriek in pain from the liquid in your eyes, and scramble to get out of',0xA,'this nightmare.  You gain a handhold, but as you pull the knob is pulled out and you are sprayed',0xA,'with yet more liquid.  You finally manage to escape your prison...but you begin to wonder just what',0xA,'kind of evil you are dealing with.', 0xA, 0 
 
Response6_4: 
	db 0xA,'(4) You leave this horrid place without looking back.  But leave with a renewed sense that',0xA,'you are fighting a great evil here.',0xA, 0 
 
 
;---------------------------------Scene 7 Responses---------------------------------- 
Response7_1: 
	db 0xA,'(1) With one mighty blow you knock one of the ghouls to the ground, as you move to the next one,', 0xA, ' pain suddenly rings out through your body.  As your vision slowly fades you realize what happened:', 0xA, ' The small girl has kicked you in the crotch.  As you come to, large men wearing uniforms are', 0xA, ' carrying you away from the house, the ghouls and the small child watching all the while.  ', 0xA, 'You look up at the men recognize their uniforms...they are guards from your own kingdom!  You had been', 0xA, ' betrayed by your master!  He must have been in league with this sinister group! If only you had known... ',0xA,  0 
 
Response7_2: 
	db 0xA,'(2) You fall to your knees before the ghouls pledging your allegiance to them.  A moment of silence', 0xA, ' passes and at last one speaks, "Umm, are you gonna fix the TV or not?".  Obeying your new masters', 0xA, ' wishes you approach the monolith and discover the cause of its inactive state: the cord is', 0xA, ' unplugged.  With a mighty yell of exertion you thrust the missing piece within the keyhole, and ', 0xA, 'a portal into another world opens up.  The ghouls share with you their approval and bid you to leave. ', 0xA, ' You run away as fast as you can, without nary a backward glance back towards the Den of Ghouls.', 0xA, '  Who knows what sort of evil you helped them unleash upon the world?  But you console yourself ', 0xA, 'with the knowledge that anyone else would have done the same in your place.',0xA, '	     The End',0xA, 0 
Response7_3: 
	db 0xA,'(3) You stand tall and demand that the Ghouls release the child.  To which they reply, "We have', 0xA, ' Jenny here for the weekend, her parents are coming back Tuesday."',0xA,  0 
Response7_4: 
	db 0xA,'(4) Gazing on the grotesque spectacle of the ghouls and the dark ritual no doubt about to commence,', 0xA, ' you turn on your heels and flee the house.  You run into the distance, arms waving and screaming.', 0xA, '  Your master will no doubt be disappointed, but you probably could not return home anyway. ', 0xA, ' After what you have seen you know the the end is surely near, best to warn others of the oncoming', 0xA, ' doom while you can.',0xA, '	     The End',0xA,  0 
 
;---------------------------------Error Checking------------------------------------- 
 
Invalid: 
	db 'The Gods demand a number between 1 and 4.  No more, no less.', 0xA, 0 
 
 
;---------------------------------Scenes:Lawn---------------------------------------- 
 
  Lawn: 
	db '-Your path has led you here.  The hour is late, the moon glows faintly behind the massing clouds.', 0xA, 'Before you lies a great field, and beyond it, lies a darkened dwelling, the end to your quest.', 0xA,'  Your master could not say what you must accomplish, but that you will discover it at journeys end.', 0xA,'  As you catch your breath you notice many menacing shadows in the dark.', 0xA,'  A diminutive battalion staring you down, with larger twisted beasts lying in wait.', 0xA, 0xA 
 
	db '    -What do you do?', 0xA 
	db '	  (1) Approach the house and knock on the front door', 0xA 
	db '	  (2) Engage the creatures in glorious battle', 0xA 
	db '	  (3) Sneak your way past the creatures', 0xA  
	db '	  (4) Cry', 0xA, 0 
  
 
;---------------------------------Scenes:Kitchen---------------------------------------- 
 
  Kitchen:  
	db 'As you pass through the door, you find yourself inside a banquet hall...albeit a small one. ', 0xA, ' There is no sign to the possessor of the voice that summoned you, but the bones of many smaller', 0xA, ' beasts litter the table, and a light shines in through a room at the far end of the room.  Opposite',0xA,'lies the entrance to a dark, ominous corridor.' , 0xA 
	db '    -What do you wish to do?', 0xA 
	db '	  (1) Sit down and eat some of the leftovers', 0xA 
	db '	  (2) Enter the lit room', 0xA 
	db '	  (3) Venture into the dark corridor', 0xA  
	db '	  (4) Stick your head in the oven', 0xA, 0 
 
;---------------------------------Scenes:Hallway------------------------------------- 
 
Hallway: 
	db '-You pass into a dark corridor, it is deathly silent.  And though you feel that some evil must be lurking', 0xA, ' nearby, nothing has yet to prove it. In the shadows ahead lies a staircase that ascends up',0xA,' to yet more darkness, the are doors to either side of you: a bright light emanating from the bottom',0xA,'  of the left door, and a dim light from the right.', 0xA 
	db '    -What do you do?', 0xA 
	db '	  (1) Ascend the stairs', 0xA 
	db '	  (2) Enter the door at your right', 0xA 
	db '	  (3) Enter the door at your left', 0xA  
	db '	  (4) Return to the banquet hall', 0xA, 0 
 
;---------------------------------Scenes:Attic--------------------------------------- 
 
Attic: 
	db '-As you reach the top of the stairs, you reach out to your surroundings.  You grab hold of a strange', 0xA, ' protrusion on the wall, which suddenly gives way, followed the room being illuminated by strange',0xA,' magical fires overhead.  Examining your surroundings more closely, you are surrounded by crates of',0xA,' indeterminate contents.  High above on a stack of crates, a creature with glowing eyes looks down on you,',0xA,' emitting a long, droning warning call.', 0xA 
	db '    -What do you do?', 0xA 
	db '	  (1) Do battle with the fell creature', 0xA 
	db '	  (2) Examine the crates', 0xA 
	db '	  (3) Challenge the creature to a game of riddles', 0xA  
	db '	  (4) Retreat to the corridor!', 0xA, 0 
 
;---------------------------------Scenes:Bedroom------------------------------------- 
 
Bedroom: 
	db '-You enter into what appears to be an elegant bedchamber.  It is elegantly decorated, which',0xA,' surprises you in this monsters lair.  The thought is quickly interrupted by sounds emanating from the',0xA,' corridor you just exited.  Many furniture pieces are organized about the room, but what draws your',0xA,' attention is a large imposing armoire in the corner of the room.', 0xA 
	db '    -What do you do?', 0xA 
	db '	  (1) Barricade the entrance', 0xA 
	db '	  (2) Search the dresser', 0xA 
	db '	  (3) Take a nap', 0xA  
	db '	  (4) Return to the corridor', 0xA, 0 
 
;---------------------------------Scenes:Bathroom------------------------------------ 
 
Bathroom: 
	db '-The inside of the dim room is small, but the contents of the room makes the dim light well-suited. ',0xA,' At the opposite side of the room sits a cauldron at to one side sits a podium, littered with',0xA,' various alchemical ingredients and potions, and a thick mirror above it.  At the other side',0xA,' is rectangular chamber, with crystal doors and various silver ornaments inside, likely some sort of',0xA,' containment chamber for some manner of experiments...', 0xA 
	db '    -What do you do?', 0xA 
	db '	  (1) Approach the podium', 0xA 
	db '	  (2) Drink a potion', 0xA 
	db '	  (3) examine the containment chamber', 0xA  
	db '	  (4) Leave this place', 0xA, 0 
 
;---------------------------------Scenes:Living Room--------------------------------- 
 
  LivingRoom: 
	db '-You walk into the lit room and the what you see before you sends a shiver down your spine.  ', 0xA, 'Two weathered, bony creatures are in the center of the room holding a small child.  ', 0xA, 'They stand behind a waist-high barricade, and hovering above an alter that lies before a great black ', 0xA, 'monolith, and they bid you forward.  You know in your heart, this is the end of your quest.  ', 0xA, 'This is your destiny...', 0xA 
	db '    -What do you do?', 0xA 
	db '	  (1) Defeat the ghouls and free the child', 0xA 
	db '	  (2) Submit to their wishes', 0xA 
	db '	  (3) Negotiate for the release of the child', 0xA  
	db '	  (4) Flee', 0xA, 0 
 
;---------------------------------Scenes:Epilogue------------------------------------ 
 
Epilogue: 
	db '					Epilogue',0xA,0xA,'-So much is wrong in the world.  That so many would ally themselves with the wretched sorcerers, instead',0xA,'of aiding you in destroying them and bringing peace to the lands. As a result you are locked away',0xA,'in some dank dungeon, to be left here for God knows for how long, likely you will be forgotten here.',0xA,'Your thoughts again turn to why you are here. Your master, and even your own kingdom has turned',0xA,'against you.....No! You will not let it end this way! You search your cell and shake the door.',0xA,'As you shake the metal bars, you find...the door is not locked.  Fortune still favors you it seems.',0xA,'As you stealthily make your way to the exit, plans for what is to come fill your head.  There',0xA,' is a great evil in the land, and you will battle it, even if you must do so alone...', 0xA,' 	     				The End',0xA, 0 
 
 



ret

